import processing.serial.*;

Serial mySerial;
String inputStr;
int xdim = 400;
int ydim = 400;

void setup() {
  size(400, 400);
  background(200);
  mySerial = new Serial(this, "COM13", 9600);
  mySerial.clear();
  mySerial.readStringUntil('\n'); //throw out first reading in case start in middle of transmission
}

void draw() {
  if (mySerial.available() > 0) {
    inputStr = mySerial.readStringUntil('\n');
    if (inputStr != null) {
      int[] readings = int(split(inputStr, ' '));
      for (int i = 0; i < 3; ++i) {
        readings[i] += 200;
        readings[i] *= 300;
        readings[i] /= 400;
      }
      int rectTotLen = 300;
      int rectWid = 50;
      background(200);
      int distBtwn = (xdim - (rectWid * 3)) / 4;
      makeRect((xdim - rectTotLen) / 2, distBtwn, readings[0], rectWid, rectTotLen);
      makeRect((xdim - rectTotLen) / 2, distBtwn * 2 + rectWid, readings[1], rectWid, rectTotLen);
      makeRect((xdim - rectTotLen) / 2, distBtwn * 3 + rectWid * 2, readings[2], rectWid, rectTotLen);
    }
  }
  delay(10);
}

void makeRect(int x, int y, int val, int wid, int totLen) {
  noStroke();
  fill(0, 0, 255);
  rect(x, y, val, wid);
  fill(255, 0, 0);
  rect(x + val, y, totLen - val, wid);
  stroke(0);
  strokeWeight(5);
  line(x + totLen / 2, y, x + totLen / 2, y + wid);
}
